function [ newClusters ] = ClustersMerge( clusters,img , colorThresh , dirTresh , MagnitudeThrish )
%**************************************************************************
%This function gets :
%clusters: First clusters segmentation
%img:The image to be segmented
%and returns the new clusters after merging 

%This function looks for neighbouring cluster that can be merged according
%to the color merging criterion and edge criterion, begnning by merging the
%begist clusters 

% clusters(i,1)->size
% clusters(i,2)->row
% clusters(i,3)->col
% clusters(i,4)->height
% clusers(i,5)->width
% clusters(i,6)->dependent cluster
% clusters(i,7)->father cluster index
%**************************************************************************
    %magnitude and direction of the image
    [ magnitude,direction ] = sobelEdgeDetect( img );
    
    [height,width]=size(clusters);
    flag=1;
    iter = 1 ;
    %repeat until regions become stable (no more merges)
    while flag==1
        i=1;
        iter 
        %find the first two neighbouring clusters that can be merged 
        while i<=height
          flag=0;
          if  clusters(i,9)~=1
                %boundaries of the first cluster
                row1=clusters(i,2);
                col1=clusters(i,3);
                height1=clusters(i,4);
                width1=clusters(i,5);
                j=1;
                cnt=0;
                while j<=height
                    % check if no more merge can be done to this cluster
                    if clusters(j,9)~=1
                         row2=clusters(j,2);
                         col2=clusters(j,3);
                         height2=clusters(j,4);
                         width2=clusters(j,5);
                         % check if the clusters are neighbours
                         flag2  = checkIfToMerge(row1,col1,height1,width1,row2,col2,height2,width2 );
                         if (clusters(j,7)==clusters(i,7))||(flag2==0)
                             cnt=cnt+1;
                         end 
                        %if they are  in the same cluster, they are already merged
                        if(clusters(j,7)~=clusters(i,7))
                            %boundaries of the second cluster
                            firstCol=clusters(clusters(i,7),8);
                            secCol=clusters(clusters(j,7),8);
                            size1=clusters(clusters(i,7),1);
                            size2=clusters(clusters(j,7),1);
                            if flag2==1
                                [flag,color]=colorCriterion2( firstCol,secCol,size1,size2,direction,magnitude,row1,col1,height1,width1,row2,col2,height2,width2 , colorThresh , dirTresh , MagnitudeThrish );
                            end
                            if flag==1
                                clusterSize1=clusters(clusters(i,7),1);
                                clusterSize2=clusters(clusters(j,7),1);
                                last1=clusters(i,7)+clusters(clusters(i,7),6);
                                
                                for m=clusters(i,7):last1
                                    clusters(m,1)=clusterSize1+clusterSize2;
                                    clusters(m,8)=color;
                                end
                                last2=clusters(j,7)+clusters(clusters(j,7),6);
                                
                                for m=clusters(j,7):last2
                                    clusters(m,1)=clusterSize1+clusterSize2;
                                    clusters(m,8)=color;
                                end
                                %If any clusters are merged, reorder the
                                %list 
                                 clusters=sortSeg(clusters,clusters(i,7),clusters(j,7));
                                    iter = iter + 1;
                                 j = height ;
                            end 
                        end
                    end
                    if (j==height)&&(flag==0)
                        clusters(i,9)=1;
                    end
                    j = j+1;
                end
          end
          if flag==1
             i=height+1;
          end
          i=i+1;
       end
    end
    newClusters=clusters;
end

