function [ newClusters,segmentedImgOriginalSize ] = MainImgSeg( img , colorThresh , dirTresh , MagnitudeThrish)
%**************************************************************************
%main function gets img: the image to be segmented and returns the final
%clusters 
%**************************************************************************
    img=double(img);
    originalImg=img;
    %prepare the image to fit the quadtree segmentation
    img  = PrepareImg( img );
    img2=img;
    [height,width]  =size(img);
    quadT(1,1)=0;
    %Representation of the image useing quadtree structure 
    quadT = quadTreeArr(img,1,1,height,width,1,0,quadT);
    
    % show the image 
    sizeS = size(quadT);
    ones = quadT(1:sizeS(1),1);
    fin = find(ones==2);
    for i=1 : length(fin)
        mean  = img ( quadT(fin(i),3):quadT(fin(i),5) , quadT(fin(i),4):quadT(fin(i),6) );
        summ = sum(sum(mean));
        g = size(mean);
        newImg( quadT(fin(i),3):quadT(fin(i),5) , quadT(fin(i),4):quadT(fin(i),6) ) = summ / (g(1)*g(2)) ;
    end
      figure,imshow( uint8(newImg));  
      %********************************************************************
      
    %Quadtree prunning
    [img,quadT ] = pruneQT( img,quadT );
    figure,imshow(uint8(img));
    %Looks for first clusters
    clusters  = mergeArray( quadT , img );
    % Sort the clusters starting with the bigest cluster,sorted in decreasing size order
    orderedClusters  = initilSort( clusters );
    %Merge stage
    newClusters  = ClustersMerge( orderedClusters , img2 , colorThresh , dirTresh , MagnitudeThrish  );
    [ segmentedImg,cnt ] = segmintesShow( newClusters ,img   );
    [ segmentedImgOriginalSize ] = OriginalImgSize( originalImg,segmentedImg );
    segmentedImgOriginalSize=uint8(segmentedImgOriginalSize);
    figure,imshow(uint8(segmentedImgOriginalSize));
end

