function [ flag,color ] = colorCriterion2( firstColur,secColor,size1,size2,direction,magnitude,row1,col1,height1,width1,row2,col2,height2,width2 , colorThresh , dirTresh , MagnitudeThrish )
%************************************************************************
% This function gets:
% firstColur: Color of the first region
% secColor: Color of the second region
% size1: Size of the first region
% size2: Size of the second region
% direction,magnitude: Direction and magnitude of the image
% row1,col1,height1,width1: Bounderies of the first region
% row2,col2,height2,width2:Bounderies of the second region

%This function returns:
%flag : boolean (1 if the regions can be merged else 0)
%color: new color of the clusters if they can be merged 

%colorCriterion2 function checks if the regions can be merged according to
%the edge criterion by checking if the bounderies of the tow regions can be merged, and color criterion 
%************************************************************************
    direction=uint8(direction);
    flag=0;
    color=(firstColur+secColor)/2;
    %cut of the tow regions (bounderies)
    if(col1-1==width2)
        if (height1-row1)>=(height2-row2)
            
            der1=direction(row2:height2,col1);
            mag1=magnitude(row2:height2,col1);
            der2=direction(row2:height2,width2);
            mag2=magnitude(row2:height2,width2);
        else

            der1=direction(row1:height1,col1);
            mag1=magnitude(row1:height1,col1);
            der2=direction(row1:height1,width2);
            mag2=magnitude(row1:height1,width2);
        end   
    end
    
    if(row1-1==height2)
        if (width1-col1)>=(width2-col2)

            der1=direction(row1,col2:width2);
            mag1=magnitude(row1,col2:width2);
            der2=direction(height2,col2:width2);
            mag2=magnitude(height2,col2:width2);
        else

            der1=direction(row1,col1:width1);
            mag1=magnitude(row1,col1:width1);
            der2=direction(height2,col1:width1);
            mag2=magnitude(height2,col1:width1);
        end      
    end
    
    
    if (height1+1==row2)
        if (width1-col1)>=(width2-col2)

            der1=direction(height1,col2:width2);
            mag1=magnitude(height1,col2:width2);
            der2=direction(row2,col2:width2);
            mag2=magnitude(row2,col2:width2);
        else

            der1=direction(height1,col1:width1);
            mag1=magnitude(height1,col1:width1);
            der2=direction(row2,col1:width1);
            mag2=magnitude(row2,col1:width1);
        end  
    end
    
    if (width1+1==col2)
        if (height1-row1)>=(height2-row2)

            der1=direction(row2:height2,width1);
            mag1=magnitude(row2:height2,width1);
            der2=direction(row2:height2,col2);
            mag2=magnitude(row2:height2,col2);
        else

            der1=direction(row1:height1,width1);
            mag1=magnitude(row1:height1,width1);
            der2=direction(row1:height1,col2);
            mag2=magnitude(row1:height1,col2);
        end   
        
    end
    %edge criterion  , colorThresh , dirTresh , MagnitudeThrish 
    if(abs(der1-der2)<=dirTresh)
        if (abs(mag1-mag2)<=MagnitudeThrish)
            %color criterion
            if abs(firstColur-secColor)<=colorThresh
                flag=1;
                color=(firstColur*size1+secColor*size2)/(size1+size2);
            end
        end
    end
    if abs(firstColur-secColor)<=10 && flag==0
        flag=1;
        color=(firstColur*size1+secColor*size2)/(size1+size2);
    end
    
    
   


end
