function [ img,QTarr ] = pruneQT( img,QTarr )
%**************************************************************************
%This function gets:
%img: Image to be segmented
%QTarr: Quadtree 

%This function returns:
%QTarr: Pruned quadtree
%img: The image with the changes

%pruneQT function merges neighboring leaves with the same parent node using a
% color criterion less restrictive than the one used in the first step
%**************************************************************************
    [height]=size(QTarr);
    cnt=1;%indicator for the array index
    indOfLeavs(1)=0;
    for i=1:height
        if QTarr(i,1)==2
            indOfLeavs(cnt)=i;
            cnt=cnt+1;
        end 
    end
    [heightLe,widthLe]=size(indOfLeavs);
    for i=1:widthLe
        parent=QTarr(indOfLeavs(1,i),2);
        firstChild=QTarr((parent*4)-2,1);
        secChild=QTarr((parent*4)-1,1);
        thiChild=QTarr((parent*4),1);
        fourChild=QTarr((parent*4)+1,1);
        %check if they are leaves
        if firstChild==2&&secChild==2&&thiChild==2&&fourChild==2 
            %Get the actual regions from the image 
            firstCol=img(QTarr((parent*4)-2,3):QTarr((parent*4)-2,5),QTarr((parent*4)-2,4):QTarr((parent*4)-2,6));
            secCol=img(QTarr((parent*4)-1,3):QTarr((parent*4)-1,5)    ,QTarr((parent*4)-1,4):QTarr((parent*4)-1,6)  );
            thiCol=img(QTarr((parent*4),3):QTarr((parent*4),5)  ,QTarr((parent*4),4):QTarr((parent*4),6)    );
            fourCol=img(QTarr((parent*4)+1,3):QTarr((parent*4)+1,5)   ,QTarr((parent*4)+1,4):QTarr((parent*4)+1,6)  );
            %Check if to merge the nodes according to a color citerion
             [flag,color]  = colorCriterion( firstCol,secCol,thiCol,fourCol,15 );
             if flag==1
                 QTarr((parent*4)-2,1)=0;
                 QTarr((parent*4)-1,1)=0;
                 QTarr((parent*4),1)=0;
                 QTarr((parent*4)+1,1)=0;
                 QTarr(parent,1)=2;
                 row=QTarr(parent,3);
                 col=QTarr(parent,4);
                 sHeight=QTarr(parent,5);
                 sWidth=QTarr(parent,6);
                 %change the color of each pixel in the region
                 for m=row:sHeight
                     for n=col:sWidth
                         img(m,n)=color;
                     end
                 end
                 
             end
        end
    end
end

