function [quadT]=quadTreeArr(img,row,col,height,width,index,parent,quadT)
%*************************************************************************
% This function gets:
% img:Image to be segmented
% row,col,height,width: Bounderies of the image to be segmented
% index:Number of the node in the tree 
% parent: Parent of the node in the that has been splitted
% quadT:Array to implement the tree

%This function returns quadtree structure that implemented using array
%structure

%quadTreeArr is a recursive function that decompose the image into blocks
% until fulfilling a MSE criterion
%First call to the function has to be with values index=1,parent =0 and the bounderies of
%the original image
%*************************************************************************


%for each node in the tree we save 6 parameters 

    quadT(index,1)=1;%indicate 1 if we used this node 2 if it is a leaf, and else 0 
    quadT(index,2)=parent;%father
    quadT(index,3)=row;%bounderies
    quadT(index,4)=col;
    quadT(index,5)=height;
    quadT(index,6)=width;
    
    %color critiria (MSE)
    img2=img(row:height,col:width);
    %region size
    img2=double(img2)/256;
    [imgH,imgW]=size(img2);
    regionSize=imgH*imgW;
    %Addition of all pixel values in region
    pixelsSum=sum(img2(:));
    avg=pixelsSum/regionSize;
    segma=sum((img2(:)-avg).^2);
    d=double(segma)/regionSize;
    threshold=0.0002;
    %Check if the region is homogeneous 
    if d < threshold
        quadT(index,1)=2;
    end
    %Check if the region is not homogeneous
    if d >=threshold
        parent=index;
        %split the node into four children
        quadT=quadTreeArr(img,row,col,row +((height-row-1)/2), col + ((width - col - 1) /2),(index*4)-2,parent,quadT);
        quadT=quadTreeArr(img,row +((height-row+1)/2),col,height,col + ((width - col - 1) /2),(index*4)-1,parent,quadT);
        quadT=quadTreeArr(img,row,col + ((width - col + 1) /2),row +((height-row-1)/2),width,(index*4),parent,quadT);
        quadT=quadTreeArr(img,row +((height-row+1)/2),col + ((width - col + 1) /2),height,width,(index*4)+1,parent,quadT);
    end
end

