function [ magnitude,direction ] = sobelEdgeDetect( img )
%**************************************************************************
%This function gets:
% img: the image to be segmented

%This function returns:
% magnitude,direction 

% sobelEdgeDetect function calculates the magnitude and direction of the image
% according to sobel edge detection
%**************************************************************************
  [height,width]=size(img);
  xPad = padarray(img,[height,width],'symmetric');
  horizontal=[-1 -2 -1;0 0 0;1 2 1];
  vertical=[-1 0 1;-2 0 2;-1 0 1];
  
  gradientH=conv2(double(xPad),double(horizontal));
  gradientV=conv2(double(xPad),double(vertical));
  
  gh=gradientH((height+1):(height+height),(width+1):(width+width));
  gv=gradientV((height+1):(height+height),(width+1):(width+width));
  %calculate the magnitude 
  magnitude=abs(gh)+abs(gv);
  imshow(uint8(magnitude));
  %calculate the direction
  direction=atan(gv./gh);
  direction(isnan(direction)) = 0 ;
end

